/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * HelpAction.cpp
 *
 *  Created on: May 8, 2010
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Helpers/MemDebug.hpp"

#include "Actions/CommandAction/HelpAction.hpp"
#include "Actions/ActionRegistry.hpp"
#include "CommandLineParser.hpp"

#include <iostream>
#include <string>

using namespace std;

#include "UIElements/UIFactory.hpp"
#include "UIElements/Dialog.hpp"
#include "Actions/ValueStorage.hpp"

const char CommandHelpAction::NAME[] = "help";

CommandHelpAction::CommandHelpAction() :
  Action(NAME)
{}

CommandHelpAction::~CommandHelpAction()
{}

void CommandHelp() {
  ActionRegistry::getInstance().getActionByName(CommandHelpAction::NAME)->call(Action::NonInteractive);
};

void CommandHelpAction::getParametersfromValueStorage()
{};

Dialog* CommandHelpAction::fillDialog(Dialog *dialog) {
  ASSERT(dialog,"No Dialog given when filling action dialog");

  ostringstream usage;
  usage << CommandLineParser::getInstance().visible << endl;
  dialog->queryEmpty(NAME, usage.str());

  return dialog;
}

Action::state_ptr CommandHelpAction::performCall() {
  return Action::success;
}

Action::state_ptr CommandHelpAction::performUndo(Action::state_ptr _state) {
  return Action::success;
}

Action::state_ptr CommandHelpAction::performRedo(Action::state_ptr _state){
  return Action::success;
}

bool CommandHelpAction::canUndo() {
  return true;
}

bool CommandHelpAction::shouldUndo() {
  return false;
}

const string CommandHelpAction::getName() {
  return NAME;
}
