/*
 * VerboseAction.hpp
 *
 *  Created on: May 9, 2010
 *      Author: heber
 */

#ifndef VERBOSEACTION_HPP_
#define VERBOSEACTION_HPP_

#include "Actions/Action.hpp"

void CommandVerbose(int verbosity);

class CommandVerboseAction : public Action {
  friend void CommandVerbose(int verbosity);

public:
  CommandVerboseAction();
  virtual ~CommandVerboseAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual void getParametersfromValueStorage();
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};

#endif /* VERBOSEACTION_HPP_ */
